/* CHCP Proxy by Vasim V. */

/* #define FLUSH_LOG */

/* #define SIGFUNC_DECL int */
/* uncomment previous line for some *nix-systems , if you got compile-error */

#include "chcproxy.h"
#include "conf.h"

#define BSD_SELECT
typedef unsigned char unsgchar;

#ifndef NT_VERSION
#ifndef UNIX_VERSION
#define INCL_DOSPROCESS
#define INCL_DOSQUEUES
#define INCL_DOSERRORS
#define INCL_DOSSEMAPHORES
#include <os2.h>
#endif				/* !UNIX_VERSION */
#else
#include <windows.h>
#endif				/* !NT_VERSION */

#if !defined(GCC_VERSION) && !defined(NT_VERSION) && !defined(UNIX_VERSION)
#include <types.h>
#else
#ifndef UNIX_VERSION
#include <errno.h>
#else
#include <sys/errno.h>
#endif
#include <sys/types.h>
#endif				/* !GCC_VERSION && !NT_VERSION &&
				 * !UNIX_VERSION */

#if !defined(NT_VERSION) || defined(GCC_VERSION) || defined (UNIX_VERSION)
#include <netinet/in.h>
#include <sys/socket.h>
#include <netdb.h>
#ifdef UNIX_VERSION
#include <arpa/inet.h>
#endif
#else
#include <winsock.h>
#endif				/* !NT_VERSION || GCC_VERSION || UNIX_VERSION */

#include <stdio.h>

#ifdef USE_CONIO
#ifdef UNIX_VERSION
#include <curses.h>
#define sock_init() initscr()
#else
#include <conio.h>
#endif				/* UNIX_VERSION */
#endif				/* USE_CONIO */

#include <string.h>
#include <ctype.h>
#include <time.h>

#ifndef NT_VERSION
#include <sys/time.h>
#ifndef UNIX_VERSION
#include <sys/select.h>
#endif				/* UNIX_VERSION */
#endif				/* !NT_VERSION */

#include "regexp/regexp.h"
#include <stdarg.h>

#ifndef UNIX_VERSION
#include <process.h>
#else
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/msg.h>
#include <sys/wait.h>
#include <stdlib.h>
#endif				/* !UNIX_VERSION */

#include <signal.h>

#define BUFFER_SIZE 3072	/* buffer size for each input/output thread */
#define MAX_THREADS 255		/* max number of threads (processes) */
#define MAX_MIME_HEADER_SIZE 1536
#define MAX_META_HEADER_SIZE 1024	/* MAX_MIME_HEADER_SIZE+MAX_META_HEDER
					 * _SIZE < BUFFER_SIZE !!! */
#define MAX_SIZE_LOG_RECORD 128	/* max size for log record */
#define MAX_INCOMING_QUEUE_SIZE 128	/* max queue size for listen */
#define THREAD_STACK_SIZE 32768	/* stack size for new threads */
#define SYS_RCVBUF_SIZE 0	/* System receive buffer size (for
				 * setsockopt) */
#define SYS_SNDBUF_SIZE 0	/* System send buffer size (for setsockopt) */
#define LINGER_TIME 240		/* time for linger option (in seconds) */
#define RESERVE_BYTES 30	/* number of reserved bytes in buffer for
				 * change charset in headers */

#ifdef CLOSE_WAIT
#define SEND_TIME_WAIT 1	/* Time for sleep after sending all data to
				 * client (in seconds) */
#endif

#define FAST_HEADER "\r\n\r\n"
#define FAST_HEADER_SIZE 4

/* Regular expressions for regcomp */
/* see 'man regexp' for details */
#define CONTENT_TYPE_FLAG "[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Tt][Yy][Pp][Ee]"
#define CHARSET_FLAG "; *[Cc][Hh][Aa][Rr][Ss][Ee][Tt]=[ !#-&(-\x7f]*"
#define TEXT_FLAG "(([Tt][Ee][Xx][Tt] */[\x20-\x7f]*)|" \
	"([Aa][Pp][Ll][Ii][Cc][Aa][Tt][Ii][Oo][Nn] */ *" \
	"[Xx]-[Ww][Ww][Ww]-[Ff][Oo][Rr][Mm]-[Uu][Rr][Ll][Ee][Nn][Cc][Oo][Dd][Ee][Dd] *))"
#define SPACE "[ \\\r\\\n\\\t]*"
#define CRLF "[\\\r\\\n]"

/* for HTTP-header */
#define CONTENT_FLAG CONTENT_TYPE_FLAG ": *" TEXT_FLAG CRLF
#define MIME_FLAG CONTENT_TYPE_FLAG ": *" TEXT_FLAG CHARSET_FLAG CRLF
#define CHARSET_SUBSTRING CHARSET_FLAG
#define LENGTH_SUBSTRING "[Cc][Oo][Nn][Tt][Ee][Nn][Tt]-[Ll][Ee][Nn][Gg][Tt][Hh]: *[0-9]+ *" CRLF
#define END_HEADER_HTTP "\\\r?\\\n\\\r?\\\n"
#define END_HEADER_SMTP "\\\r?\\\n"
#define END_BODY_SMTP "\\\r?\\\n\\.\\\r?\\\n"
#define LINE_LOG_HEADER "((([Gg][Ee][Tt])|([Hh][Ee][Aa][Dd])) *[ -~]*)" CRLF

/* for detect HTTP/1.1 connection or HTTP/1.0 persistent connection */
#define PERSIST_FLAG "(([Hh][Tt][Tt][Pp]/1\\.1)|([Kk][Ee][Ee][Pp]-[Aa][Ll][Ii][Vv][Ee]))"
#define CLOSE_FLAG "[Cc][Oo][Nn][Nn][Ee][Cc][Tt][Ii][Oo][Nn]: *[Cc][Ll][Oo][Ss][Ee]" CRLF

#define LIFE_FLAG "[ -~]*[Kk][Ee][Ee][Pp]-[Aa][Ll][Ii][Vv][Ee][ -~]*\\\r?\\\n"

/* for htmls from Microsoft FrontPage . *WHY* ?!?!?!?!? :~~~( */
#define META_FLAG "<" SPACE "[Mm][Ee][Tt][Aa]" SPACE \
	"[Hh][Tt][Tt][Pp]-[Ee][Qq][Uu][Ii][Vv]" SPACE \
	"=" SPACE "[\"\']" CONTENT_TYPE_FLAG "[\"\']" SPACE \
	"[Cc][Oo][Nn][Tt][Ee][Nn][Tt]" SPACE "=" SPACE \
	"[\"\']" TEXT_FLAG CHARSET_FLAG "[\"\']" SPACE ">"

#define HOST_FORMAT "[Hh][Oo][Ss][Tt]: *((%s)|(%s))%s *\\\r?\\\n"

#if defined(GCC_VERSION) || defined(UNIX_VERSION)
#define ERRNO errno
#define S_EINTR EINTR
#define SBUF int
#ifdef UNIX_VERSION
#define strcmpi(x,y) strcasecmp(x,y)
#else
#define strcmpi(x,y) stricmp(x,y)
#endif				/* UNIX_VERSION */
#ifndef sock_init
#define sock_init()
#endif
#define sock_deinit()
#define soclose(x) close(x)
#define psock_errno perror
#endif				/* GCC_VERSION || UNIX_VERSION */

#ifdef NT_VERSION
#define gettid() (int) GetCurrentThreadId()
#define DosSleep(x) Sleep(x)
#define DosKillThread(x) TerminateThread(x,0)
#define MSGID HANDLE
#define NULLHANDLE (HANDLE)0
#define THRID HANDLE

#ifndef GCC_VERSION
#define S_EINTR WSAEINTR
#define soclose(x) closesocket(x)
#define sock_deinit() WSACleanup()
#define ERRNO WSAGetLastError()
#define SBUF int

void
psock_errno(char *s)
{
  fprintf(stderr, "winsock (%d) : %s\n", WSAGetLastError(), s);
}

void
sock_init()
{
  WSADATA         wsaData;
  int             res;

  res = WSAStartup(MAKEWORD(1, 1), &wsaData);
  if (res != 0)
  {
    psock_errno("WSAStartup failed .");
    exit(1);
  }
}

#endif				/* GCC_VERSION */

#define QUEUE_SIZE 100
#define H_EVENT HANDLE
char           *queue[QUEUE_SIZE];
int             head, tail;
HANDLE          lock;
HANDLE          semwrite;

void
_lock_log()
{
  WaitForSingleObject(lock, INFINITE);
}

void
_unlock_log()
{
  ReleaseMutex(lock);
}

void
_wait_event(HANDLE sem)
{
  WaitForSingleObject(sem, INFINITE);
}

void
_pulse_event(HANDLE sem)
{
  PulseEvent(sem);
}

void
_reset_event(HANDLE sem)
{
  ResetEvent(sem);
}

HANDLE
_create_event()
{
  return CreateEvent(NULL, TRUE, FALSE, 0);
}

void
_close_event(HANDLE sem)
{
  CloseHandle(sem);
}

void
_create_message(MSGID msgid)
{
  head = 0;
  tail = 0;
  lock = CreateMutex(NULL, FALSE, NULL);
  semwrite = _create_event();
}

void
_close_message(MSGID msgid)
{
  _close_event(semwrite);
  CloseHandle(lock);
}

void
_send_message(MSGID msgid, char *msg)
{
  char           *data;

  _lock_log();
  if (((head + QUEUE_SIZE - 1) % QUEUE_SIZE) != tail)
  {
    data = (char *) malloc(MAX_SIZE_LOG_RECORD);
    memcpy(data, msg, MAX_SIZE_LOG_RECORD);
    queue[tail] = data;
    tail = (tail + 1) % QUEUE_SIZE;
    _unlock_log();
    _pulse_event(semwrite);
  } else
    _unlock_log();
}

void
_receive_message(MSGID msgid, char *msg)
{
  char           *data;

  if (head == tail)
    _wait_event(semwrite);
  _lock_log();
  _reset_event(semwrite);
  data = queue[head];
  head = (head + 1) % QUEUE_SIZE;
  _unlock_log();
  memcpy(msg, data, MAX_SIZE_LOG_RECORD);
  free(data);
}

#else
#ifndef UNIX_VERSION

#define THRID int
#define MSGID HQUEUE
#define H_EVENT HEV
#define _close_message(x) DosCloseQueue(x)
#define _create_message(x) _create_message_queue(&x)

int
gettid()
{
  PPIB            ppib;
  PTIB            ptib;

  (void) DosGetInfoBlocks(&ptib, &ppib);
  return (int) (ptib->tib_ptib2->tib2_ultid);
}

void
_create_message_queue(MSGID * msgid)
{
  char            name[64];

  sprintf(name, "\\QUEUES\\CHCPROXY.%d", getpid());
  DosCreateQueue(msgid, QUE_FIFO, name);
}

void
_send_message(MSGID msgid, char *msg)
{
  char           *data;

  data = (char *) malloc(MAX_SIZE_LOG_RECORD);
  memcpy(data, msg, MAX_SIZE_LOG_RECORD);
  DosWriteQueue(msgid, (ULONG) 1, sizeof(data), data, 0L);
}

void
_receive_message(MSGID msgid, char *msg)
{
  REQUESTDATA     req = {0};
  char           *data;
  ULONG           len = 0;
  BYTE            prt = 0;

  req.pid = getpid();
  DosReadQueue(msgid, &req, &len, (void **) &data, 0L, DCWW_WAIT, &prt, 0L);
  memcpy(msg, data, MAX_SIZE_LOG_RECORD);
  free(data);
}

HEV
_create_event()
{
  HEV		  handle;

  DosCreateEventSem(NULL, &handle, 0L, FALSE);
  return handle;
}

void
_close_event(HEV sem)
{
  DosCloseEventSem(sem);
}

void
_reset_event(HEV sem)
{
  ULONG		  stat;

  DosResetEventSem(sem, &stat);
}

void
_pulse_event(HEV sem)
{
  DosPostEventSem(sem);
}

void
_wait_event(HEV sem)
{
  DosWaitEventSem(sem, SEM_INDEFINITE_WAIT);
}

#ifndef GCC_VERSION
#define S_EINTR SOCEINTR
#define sock_deinit()
#define ERRNO sock_errno()
#define SBUF long
#endif

#else

#define THRID int
#define gettid() getpid()
#define DosKillThread(x) kill(x,SIGUSR1)
#define DosSleep(x) sleep(x/1000);
#define MSGID int
#define NULLHANDLE 0
#define _create_message(x) x=msgget(IPC_PRIVATE, IPC_CREAT | 0700)
#define _close_message(x) msgctl(x, IPC_RMID, NULL)

typedef struct mbuf
{
  long            mtype;
  char            mtext[MAX_SIZE_LOG_RECORD];
}               mbuf;

void
_send_message(MSGID msgid, char *msg)
{
  mbuf            buf;

  buf.mtype = 1;
  memcpy(buf.mtext, msg, sizeof(buf.mtext));
  msgsnd(msgid, &buf, sizeof(buf), 0);
}

void
_receive_message(MSGID msgid, char *msg)
{
  mbuf            buf;

  msgrcv(msgid, &buf, sizeof(buf), 0, 0);
  memcpy(msg, buf.mtext, sizeof(buf.mtext));
}
#endif				/* !UNIX_VERSION */
#endif				/* NT_VERSION */

/* Data types */
typedef struct sockets
{
  int             proxy_sock;
  int             in_sock;
  int             table;
  int             statr0, statr1, stats0, stats1;
  int		  flag_exit;
  THRID		  child_pid;
#ifdef UNIX_VERSION
  THRID           parent_pid;
#else
  H_EVENT	  hev;
#endif				/* UNIX_VERSION */
}               sockets;

typedef struct shared_data
{
  int             number_threads;
  int             flag_exit;
  int             translate_from_page;
  int             translate_to_page;
  THRID           server_pid;
  THRID           log_pid;
  int             flag_all_translate;	/* 1 - translate all , 0 - only text */
  int             flag_hex_translate;	/* 1 - translate hex codes , 0 -
					 * ignore hex */
  int             flag_replace_mime;	/* 0 - Cut (Very bad idea !!!) , 1 -
					 * Replace , 2 - Cut '; charset =
					 * xxx' substring, -1 - No action */
  int             flag_replace_meta;	/* 0 - Cut (Very good idea :) ) , 1 -
					 * Replace , 2 - Cut '; charset =
					 * xxx' substring, -1 - No action */
  int             flag_charset_priority;	/* 0 - don't use any headers
						 * (use default charset) 1 -
						 * use charset from
						 * mime-header only , 2 - use
						 * charset from meta only , 3
						 * - use charset from meta
						 * and mime-header
						 * (mime-header is priority)
						 * 4 - use charset from met
						 * and mime-header (meta is
						 * priority) */
  unsgchar        table_to[5][256];
  unsgchar        table_from[5][256];
}               shared_data;

typedef struct bufhex
{
  unsgchar       *buf;
  int             size;
  int             flhexw;
  int             offset;
  int             hexchar;
  int             fsize;
}               bufhex;

typedef struct buffer
{
  unsgchar        buf[BUFFER_SIZE];
  int             size;		/* number of bytes in buffer */
  bufhex          hex;		/* data for translate_hex() (internal) */
  int             scount;	/* number of bytes for send from buffer (must
				 * be 0 after send !) */
  int             lastsend;	/* number of bytes in last send operation
				 * (internal) */
  int             ver;		/* 1 - http/1.1 or persistent connection */
  int             fsize;	/* remain bytes in current file */
  unsgchar       *psend;	/* pointer on bytes for send */
  int             charset;	/* input charset (internal) */
  int             flheadw;	/* 'wait header' flag (internal) */
  int             fltrans;	/* 'need translate' flag (internal) */
  int             flconn;	/* connection status (0 - connection closed) */
  int             sock;		/* socket descriptor */
  int             dir;		/* direction (1 - from proxy to client, 2 -
				 * from client to proxy) */
  int             length;	/* length from mime-header (internal) */
  unsgchar       *pend;		/* pointer to end mime-header (internal) */
  int             charset_mime;	/* charset from mime-header (internal) */
  unsgchar       *pbegs;	/* (internal) */
  unsgchar       *pends;	/* (internal) */
}               buffer;

/* Global data for all processes */
struct regexp  *etable[5];
struct regexp  *emeta;
struct regexp  *echarset;
struct regexp  *emime;
struct regexp  *econtent;
struct regexp  *elength;
struct regexp  *eendhttp;
struct regexp  *eendsmtp;
struct regexp  *eendbody;
struct regexp  *epersist;
struct regexp  *elife;
struct regexp  *ehost;
struct regexp  *eclose;
struct regexp  *elinelog;
char           *table_exp[5] = {"[Kk][Oo][Ii][- ]?8[- ]?.?", \
  "(([Cc][Pp])|(([Ww][Ii][Nn])([Dd][Oo][Ww][Ss]?)?)|([Aa][Nn][Ss][Ii]))[- ]?1251", \
  "[Ii][Ss][Oo]-?8859-?5", \
  "YOUR", \
  "(([Cc][Pp])|([Aa][Ll][Tt])|([Ii][Bb][Mm]))[- ]?866"};

/* Names of charsets for replace in headers */
char           *table_name[5] = {"koi8-r", "windows-1251", "iso-8859-5", "your", "cp866"};

char           *flrep_name[4] = {"Pass w/o changes", "Cut all", "Replace charset", \
  "Cut only \'; charset=xxx\'"};
char           *flpri_name[5] = {"Ignore headers", "Look in MIME-header only", \
  "Look in META only", "Look in MIME-header then META", \
  "Look in META then MIME-header"};
FILE           *logerr;
unsigned long   proxy_address;
unsigned short  proxy_port;
MSGID           msglog = NULLHANDLE;
unsgchar        tbcp[4][224];
int             sock;
int             flag_unattended;
int             send_buffer_size;
int             receive_buffer_size;
unsgchar	hexhead;

#ifdef UNIX_VERSION
int             global_id;	/* id of shared memory segment */
#else
struct shared_data global_data;
#endif				/* UNIX_VERSION */
struct shared_data *gl;

#ifndef C_SET_VERSION
#define _Optlink
#ifdef GCC_VERSION
#define _Inline __inline__
#else
#define _Inline
#endif				/* GCC_VERSION */
#endif				/* !C_SET_VERSION */

#ifndef SIGFUNC_DECL
#define SIGFUNC_DECL void
#endif

void _Optlink   new_request(void *num_socket);
void _Optlink   to_proxy_thread(void *idsocks);
#define REQUEST_MULTI new_request

void _Optlink   Request(void *num_socket);
#define REQUEST_ONE Request

void            menu(int ansi_flag, struct shared_data * gl);
void _Optlink   server_thread(void *socknum);
void            translate(unsgchar * buf, int size, int flag_translate, int table, struct shared_data * gl);
int             sendflush(int sock, unsgchar * buf, int size, int *stat, int *flag_stop);
void            translate_hex(bufhex * hbuf, int size, int flag_translate, struct shared_data * gl, int table);
void            init_buffer(buffer * buf, struct shared_data * gl);
int             receive_buffer(buffer * buf, struct shared_data * gl, int *stat, int *flag_stop);
_Inline int     xc2d(unsgchar c);
_Inline unsgchar d2xc(int k);
_Inline void    hex_translate(unsgchar * buf, int flag_translate, int table, struct shared_data * gl);
void            fill_tables_translation(struct shared_data * gl);
void            load_table(int table, char *filename);
void _Optlink   log_thread(void *nullpar);
void            log(const char *fmt,...);
SIGFUNC_DECL    quit(int x);
extern int      read_cfg(FILE * in, conf_rec conf[], int conf_param_num);
int             table_number(int t);
char           *to_regexp(char *s);

#ifdef WATCOM_VERSION
#pragma	intrinsic (xc2d, d2xc, hex_translate)
#endif

#ifdef C_SET_VERSION
#define C_VERSION "IBM C/Set"
#else
#ifdef WATCOM_VERSION
#define C_VERSION "Watcom C"
#else
#ifdef GCC_VERSION
#define C_VERSION "Gcc"
#else
#define C_VERSION "Unknown"
#endif				/* GCC_VERSION */
#endif				/* WATCOM_VERSION */
#endif				/* C_SET_VERSION */

#ifdef NT_VERSION
#define C_VERSION_1 C_VERSION " [Win32]"
#else
#ifdef UNIX_VERSION
#define C_VERSION_1 C_VERSION " [Unix]"
#else
#define C_VERSION_1 C_VERSION " [OS/2]"
#endif
#endif				/* NT_VERSION */

#ifdef USE_CONIO
#ifdef UNIX_VERSION
#define COMPILER_VERSION C_VERSION_1 " with curses.h"
#else
#define COMPILER_VERSION C_VERSION_1 " with conio.h"
#endif				/* UNIX_VERSION */
#else
#define COMPILER_VERSION C_VERSION_1 " without conio.h"
#endif				/* USE_CONIO */

void
reg_error(char *s)
{
  fprintf(stderr, "regexp: %s", s);
  exit(1);
}

#ifdef UNIX_VERSION
int
                _beginthread(void (*func) (void *), void *stack, int ssize, void *param)
{
  int             rc;

  rc = fork();
  if (rc < 0)
    return -1;
  else if (rc > 0)
  {
    return rc;
  } else
  {
    (*func) (param);
    exit(0);
  }
}

void
_endthread()
{
  exit(0);
}
#endif				/* UNIX_VERSION */

#define REGDUP(x,y) regdup(x,y)

void
set_signals()
{
#ifdef SIGHUP
  signal(SIGHUP, quit);
#endif
#ifdef SIGINT
  signal(SIGINT, quit);
#endif
#ifdef SIGTERM
  signal(SIGTERM, quit);
#endif
#ifdef SIGALRM
  signal(SIGALRM, quit);
#endif
#ifdef SIGXCPU
  signal(SIGXCPU, quit);
#endif
#ifdef SIGVTALRM
  signal(SIGVTALRM, quit);
#endif
#ifdef SIGPROF
  signal(SIGPROF, quit);
#endif
#ifdef SIGBREAK
  signal(SIGBREAK, quit);
#endif
#ifdef SIGQUIT
  signal(SIGQUIT, quit);
#endif
  signal(SIGUSR2, quit);
  signal(SIGUSR1, quit);
  return;
}

void
unset_signals()
{
#ifdef SIGPIPE
  signal(SIGPIPE, SIG_IGN);
#endif
#ifdef SIGHUP
  signal(SIGHUP, SIG_IGN);
#endif
#ifdef SIGINT
  signal(SIGINT, SIG_IGN);
#endif
#ifdef SIGTERM
  signal(SIGTERM, SIG_IGN);
#endif
#ifdef SIGALRM
  signal(SIGALRM, SIG_IGN);
#endif
#ifdef SIGXCPU
  signal(SIGXCPU, SIG_IGN);
#endif
#ifdef SIGVTALRM
  signal(SIGVTALRM, SIG_IGN);
#endif
#ifdef SIGPROF
  signal(SIGPROF, SIG_IGN);
#endif
#ifdef SIGQUIT
  signal(SIGQUIT, SIG_IGN);
#endif
  signal(SIGUSR2, SIG_IGN);
#ifdef SIGBREAK
  signal(SIGBREAK, SIG_IGN);
#endif
  return;
}

#ifdef UNIX_VERSION
SIGFUNC_DECL
exitsig(int sig)
{
  signal(SIGUSR1, SIG_IGN);
  shmdt((void *) gl);
  exit(sig);
}
#endif				/* UNIX_VERSION */

#ifdef UNIX_VERSION
#define V_ONE_THREAD 1
#else
#define V_ONE_THREAD 0
#endif				/* UNIX_VERSION */

#if defined(NT_VERSION) || defined(UNIX_VERSION)
#define V_ANSI 0
#else
#define V_ANSI 1
#endif				/* NT_VERSION || UNIX_VERSION */

int             pport, pproxy_port;
char           *logname;
int             flall, flhex, chpri, flrmime, flrmeta, trfrom, trto;
int             flag_ansi;
char           *proxy_addr;

int             max_threads = MAX_THREADS;
int             input_queue = MAX_INCOMING_QUEUE_SIZE;
int             linger = 0;
int             linger_time = LINGER_TIME;
int             one_thread = V_ONE_THREAD;
int             flag_no_alive = 0;
int             flag_fast_send = 1;
int             flag_host_replace = 0;
int		flag_multihomed = 0;
int		flag_log_header = 0;
char           *hostname;
char           *hostip;
char           *orighostname;
char           *exphost;
int		flag_smtp = 0;
int		flag_quote = 0;
int		flag_dumb_charset = 0;

void
main(int argc, char **argv)
{
  unsigned short  port;
  struct sockaddr_in server;
  struct hostent *host_proxy;
  unsigned long   my_ip_address;
  int             res;
  int             i;
  int             on = 1;
  THRID           thrid;
  char            temp[10];
  char           *temphostname;
  char           *temphostip;

  FILE           *confin;

#define CONF_PARAM_NUM 30
  conf_rec        conf[CONF_PARAM_NUM] = {{B_SPACE "[Pp][Oo][Rr][Tt]" E_SPACE, 3, (void **) &pport, 0, (void *) 8080}, \
  {B_SPACE "[Pp][Rr][Oo][Xx][Yy][Pp][Oo][Rr][Tt]" E_SPACE, 3, (void **) &pproxy_port, 0, (void *) 80}, \
  {B_SPACE "[Pp][Rr][Oo][Xx][Yy]" E_SPACE, 2, (void **) &proxy_addr, 0, (void *) "localhost"}, \
  {B_SPACE "[Aa][Ll][Ll][Tt][Rr][Aa][Nn][Ss][Ll][Aa][Tt][Ee]" E_SPACE, 1, (void **) &flall, 0, (void *) 0}, \
  {B_SPACE "[Hh][Ee][Xx][Tt][Rr][Aa][Nn][Ss][Ll][Aa][Tt][Ee]" E_SPACE, 1, (void **) &flhex, 0, (void *) 1}, \
  {B_SPACE "[Ff][Rr][Oo][Mm][Cc][Hh][Aa][Rr][Ss][Ee][Tt]" E_SPACE, 3, (void **) &trfrom, 0, (void *) 1251}, \
  {B_SPACE "[Tt][Oo][Cc][Hh][Aa][Rr][Ss][Ee][Tt]" E_SPACE, 3, (void **) &trto, 0, (void *) 0}, \
  {B_SPACE "[Oo][Rr][Dd][Ee][Rr]" E_SPACE, 3, (void **) &chpri, 0, (void *) 4}, \
  {B_SPACE "[Rr][Ee][Pp][Ll][Aa][Cc][Ee][Mm][Ii][Mm][Ee]" E_SPACE, 3, (void **) &flrmime, 0, (void *) 2}, \
  {B_SPACE "[Rr][Ee][Pp][Ll][Aa][Cc][Ee][Mm][Ee][Tt][Aa]" E_SPACE, 3, (void **) &flrmeta, 0, (void *) 0}, \
  {B_SPACE "[Aa][Nn][Ss][Ii]" E_SPACE, 1, (void **) &flag_ansi, 0, (void *) V_ANSI}, \
  {B_SPACE "[Uu][Nn][Aa][Tt][Tt][Ee][Nn][Dd][Ee][Dd]" E_SPACE, 1, (void **) &flag_unattended, 0, (void *) 0}, \
  {B_SPACE "[Ll][Oo][Gg]" E_SPACE, 2, (void **) &logname, 0, (void *) "stderr"}, \
  {B_SPACE "[Ss][Ee][Nn][Dd][Bb][Uu][Ff][Ff][Ee][Rr]" E_SPACE, 3, (void **) &send_buffer_size, 0, (void *) SYS_SNDBUF_SIZE}, \
  {B_SPACE "[Rr][Ee][Cc][Ee][Ii][Vv][Ee][Bb][Uu][Ff][Ff][Ee][Rr]" E_SPACE, 3, (void **) &receive_buffer_size, 0, (void *) SYS_RCVBUF_SIZE}, \
  {B_SPACE "[Ll][Ii][Nn][Gg][Ee][Rr]" E_SPACE, 1, (void **) &linger, 0, (void *) 0}, \
  {B_SPACE "[Ll][Ii][Nn][Gg][Ee][Rr][Tt][Ii][Mm][Ee]" E_SPACE, 3, (void **) &linger_time, 0, (void *) LINGER_TIME}, \
  {B_SPACE "[Mm][Aa][Xx][Tt][Hh][Rr][Ee][Aa][Dd][Ss]" E_SPACE, 3, (void **) &max_threads, 0, (void *) MAX_THREADS}, \
  {B_SPACE "[Ii][Nn][Pp][Uu][Tt][Qq][Uu][Ee][Uu][Ee]" E_SPACE, 3, (void **) &input_queue, 0, (void *) MAX_INCOMING_QUEUE_SIZE}, \
  {B_SPACE "[Oo][Nn][Ee][Tt][Hh][Rr][Ee][Aa][Dd]" E_SPACE, 1, (void **) &one_thread, 0, (void *) V_ONE_THREAD}, \
  {B_SPACE "[Cc][Uu][Tt][Aa][Ll][Ii][Vv][Ee]" E_SPACE, 1, (void **) &flag_no_alive, 0, (void *) 0}, \
  {B_SPACE "[Ff][Aa][Ss][Tt][Dd][Ee][Tt][Ee][Cc][Tt][Hh][Ee][Aa][Dd][Ee][Rr]" E_SPACE, 1, (void **) &flag_fast_send, 0, (void *) 1}, \
  {B_SPACE "[Hh][Oo][Ss][Tt][Nn][Aa][Mm][Ee]" E_SPACE, 2, (void **) &hostname, 0, (void *) "localhost"}, \
  {B_SPACE "[Hh][Oo][Ss][Tt][Ii][Pp]" E_SPACE, 2, (void **) &hostip, 0, (void *) "127.0.0.1"}, \
  {B_SPACE "[Rr][Ee][Pp][Ll][Aa][Cc][Ee][Hh][Oo][Ss][Tt]" E_SPACE, 1, (void **) &flag_host_replace, 0, (void *) 2}, \
  {B_SPACE "[Mm][Uu][Ll][Tt][Ii][Hh][Oo][Mm][Ee][Dd]" E_SPACE, 1, (void **) &flag_multihomed, 0, (void *) 0}, \
  {B_SPACE "[Qq][Uu][Oo][Tt][Ee][Pp][Rr][Ii][Nn][Tt][Aa][Bb][Ll][Ee]" E_SPACE, 1, (void **) &flag_quote, 0, (void *) 0}, \
  {B_SPACE "[Ss][Mm][Tt][Pp][Nn][Nn][Tt][Pp]" E_SPACE, 1, (void **) &flag_smtp, 0, (void *) 0}, \
  {B_SPACE "[Hh][Ee][Aa][Dd][Ll][Oo][Gg]" E_SPACE, 1, (void **) &flag_log_header, 0, (void *) 0}, \
  {B_SPACE "[Dd][Uu][Mm][Bb][Cc][Hh][Aa][Rr][Ss][Ee][Tt]" E_SPACE, 1, (void **) &flag_dumb_charset, 0, (void *) 0}};

  sock_init();

  if (((argc < 7) || (argc > 16)) && (argc != 2))
  {
    fprintf(stderr, "Usage: %s port proxy proxy_port from_codepage to_codepage flag_all_translate flag_hex_translate flag_header_priority flag_replace_mime flag_replace_meta logfile_name flag_ansi flag_unattended_mode send_buffer_size receive_buffer_size\n or\n %s config_file_name\n", argv[0], argv[0]);
    exit(1);
  }
  if ((econtent = regcomp(CONTENT_FLAG)) == NULL)
    reg_error("error at compile CONTENT_FLAG");
  if ((echarset = regcomp(CHARSET_SUBSTRING)) == NULL)
    reg_error("error at compile CHARSET_SUBSTRING");
  if ((emime = regcomp(MIME_FLAG)) == NULL)
    reg_error("error at compile MIME_FLAG");
  if ((emeta = regcomp(META_FLAG)) == NULL)
    reg_error("error at compile META_FLAG");
  if ((eendhttp = regcomp(END_HEADER_HTTP)) == NULL)
    reg_error("error at compile END_HEADER_HTTP");
  if ((eendsmtp = regcomp(END_HEADER_SMTP)) == NULL)
    reg_error("error at compile END_HEADER_SMTP");
  if ((eendbody = regcomp(END_BODY_SMTP)) == NULL)
    reg_error("error at compile END_BODY_SMTP");
  if ((elength = regcomp(LENGTH_SUBSTRING)) == NULL)
    reg_error("error at compile LENGTH_SUBSTRING");
  if ((epersist = regcomp(PERSIST_FLAG)) == NULL)
    reg_error("error at compile PERSIST_FLAG");
  if ((elife = regcomp(LIFE_FLAG)) == NULL)
    reg_error("error at compile LIFE_FLAG");
  if ((eclose = regcomp(CLOSE_FLAG)) == NULL)
    reg_error("error at compile CLOSE_FLAG");
  if ((elinelog = regcomp(LINE_LOG_HEADER)) == NULL)
    reg_error("error at compile LINE_LOG_HEADER");
  for (i = 0; i < 5; i++)
    if ((etable[i] = regcomp(table_exp[i])) == NULL)
      reg_error("error at compile table_exp");

  if (argc == 2)
  {
    confin = fopen(argv[1], "r");
    if (confin == NULL)
    {
      fprintf(stderr, "Can\'t open config file\n");
      exit(1);
    }
    res = read_cfg(confin, conf, CONF_PARAM_NUM);
    if (res != 0)
    {
      fprintf(stderr, "Error in config file %s (line %d)\n", argv[1], res);
      exit(1);
    }
    fclose(confin);
    port = (unsigned short) pport;
    proxy_port = (unsigned short) pproxy_port;
  } else
  {
    proxy_addr = argv[2];
    port = (unsigned short) atoi(argv[1]);
    proxy_port = (unsigned short) atoi(argv[3]);
  }

  if (flag_quote)
    hexhead = '=';
  else
    hexhead = '%';

  if (!strcmpi(proxy_addr, "localhost"))
    proxy_address = (1 * 256 * 256 * 256) + 127;
  else
  {
    if ((proxy_addr[0] >= '0') && (proxy_addr[0] <= '9'))
      proxy_address = inet_addr(proxy_addr);
    else
    {
      host_proxy = gethostbyname(proxy_addr);
      if (host_proxy == NULL)
      {
	fprintf(stderr, "Proxy address %s is unknown\n", proxy_addr);
	sock_deinit();
	exit(-1);
      } else
	proxy_address = *((unsigned long *) host_proxy->h_addr);
    }
  }

  my_ip_address = INADDR_ANY;
  if (flag_multihomed)
  {
    if ((hostip[0] >= '0') && (hostip[0] <= '9'))
      my_ip_address = inet_addr(hostip);
    else
    {
      host_proxy = gethostbyname(hostip);
      if (host_proxy == NULL)
      {
	fprintf(stderr, "Current host address %s is unknown\n", hostip);
	sock_deinit();
	exit(-1);
      } else
	my_ip_address = *((unsigned long *) host_proxy->h_addr);
    }
  }

#ifndef UNIX_VERSION
  gl = &global_data;
#else

  global_id = shmget(IPC_PRIVATE, sizeof(struct shared_data), IPC_CREAT | SHM_R | SHM_W);
  if (global_id < 0)
  {
    perror("Error at create shared memory segment");
    exit(2);
  }
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
#endif				/* !UNIX_VERSION */
  gl->flag_exit = 0;
  gl->server_pid = (THRID) - 1;
  gl->log_pid = (THRID) - 1;

  if (argc != 2)
  {
    gl->translate_from_page = table_number(atoi(argv[4]));
    gl->translate_to_page = table_number(atoi(argv[5]));
    gl->flag_all_translate = (atoi(argv[6]) != 0);
    if (argc > 7)
      gl->flag_hex_translate = (atoi(argv[7]) != 0);
    else
      gl->flag_hex_translate = !gl->flag_all_translate;
    if (argc < 9)
      gl->flag_charset_priority = 4;
    else
      gl->flag_charset_priority = atoi(argv[8]);
    if (argc < 10)
      gl->flag_replace_mime = 2;
    else
      gl->flag_replace_mime = atoi(argv[9]);
    if (argc < 11)
      gl->flag_replace_meta = 0;
    else
      gl->flag_replace_meta = atoi(argv[10]);
    if (argc < 13)
      flag_ansi = V_ANSI;
    else
      flag_ansi = (atoi(argv[12]) != 0);
    flag_unattended = 0;
    if (argc >= 14)
      if (atoi(argv[13]))
      {
	flag_unattended = 1;
	fclose(stdout);
	fclose(stderr);
	fclose(stdin);
      }
    if (argc < 15)
      send_buffer_size = SYS_SNDBUF_SIZE;
    else
      send_buffer_size = atoi(argv[14]);
    if (argc < 16)
      receive_buffer_size = SYS_RCVBUF_SIZE;
    else
      receive_buffer_size = atoi(argv[15]);
    if (argc < 12)
      logname = "stderr";
    else
    {
      logname = argv[11];
    }
    flag_host_replace = 2;
    hostname = (char *) malloc(10);
    memcpy(hostname, "localhost\0", 10);
    hostip = (char *) malloc(10);
    memcpy(hostip, "127.0.0.1\0", 10);
  } else
  {
    gl->flag_all_translate = flall;
    gl->flag_hex_translate = flhex;
    gl->translate_from_page = table_number(trfrom);
    gl->translate_to_page = table_number(trto);
    gl->flag_charset_priority = chpri;
    gl->flag_replace_mime = flrmime;
    gl->flag_replace_meta = flrmeta;
  }
  orighostname = (char *) malloc(strlen(proxy_addr) + 16);
  if (proxy_port != 80)
    sprintf(orighostname, "Host: %s:%d\r\n", proxy_addr, proxy_port);
  else
    sprintf(orighostname, "Host: %s\r\n", proxy_addr);

  if (port != 80)
    sprintf(temp, ":%d", port);
  else
    sprintf(temp, "(:%d)?", port);

  temphostname = to_regexp(hostname);
  temphostip = to_regexp(hostip);
  exphost = (char *) malloc(strlen(temphostname) + strlen(temphostip) + strlen(temp) + 48);
  sprintf(exphost, HOST_FORMAT, temphostname, temphostip, temp);
  free(hostname);
  free(hostip);
  free(temphostname);
  free(temphostip);

  if (flag_host_replace == 2)
    flag_host_replace = !gl->flag_all_translate;

  if (!strcmpi(logname, "stderr") || (flag_unattended && (!strcmpi(logname, "nul") ||
						!strcmpi(logname, "null") ||
					   !strcmpi(logname, "/dev/null"))))
    logerr = stderr;
  else if ((logerr = fopen(logname, "a")) == NULL)
  {
    logerr = stderr;
    flag_unattended = 1;
    fprintf(stderr, "Can\'t open log file \'%s\'\n", logname);
    quit(-1);
  }
  if (argc == 2)
  {
    free(logname);
    free(proxy_addr);
  }
  if (!flag_unattended || (logerr != stderr))
    _create_message(msglog);
  load_table(0, "koi_866.cdp");
  load_table(1, "win_866.cdp");
  load_table(2, "iso_866.cdp");
  load_table(3, "tmp_866.cdp");

  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0)
  {
    psock_errno("Create main socket");
    quit(-1);
  }
  setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (void *) &on, sizeof(on));
  setsockopt(sock, SOL_SOCKET, SO_KEEPALIVE, (void *) &on, sizeof(on));
  memset((void *) &server, 0, sizeof(server));
  server.sin_family = AF_INET;
  server.sin_port = htons(port);
  server.sin_addr.s_addr = my_ip_address;

  res = bind(sock, (struct sockaddr *) & server, sizeof(server));
  if (res < 0)
  {
    psock_errno("Bind main socket");
    quit(-1);
  }
  res = listen(sock, input_queue);
  if (res != 0)
  {
    psock_errno("Listen main socket");
    quit(-1);
  }
  gl->number_threads = 3;
  ehost = regcomp(exphost);

  if (!flag_unattended || (logerr != stderr))
  {
    res = _beginthread(&log_thread, NULL, THREAD_STACK_SIZE, NULL);
    if (res == -1)
    {
      fprintf(stderr, "Startup : _beginthread (fork) error (at run log thread).");
      quit(-1);
    }
  }

#ifdef DEBUG
  /* DEBUG */
  log("Startup : DEBUG : exphost \'%s\'", exphost);
#endif
  free(exphost);
  if (ehost == NULL)
  {
    log("Startup : Error at compile HOST_FORMAT (check HostName and HostIp) .");
    quit(-1);
  }
  fill_tables_translation(gl);

  res = _beginthread(&server_thread, NULL, THREAD_STACK_SIZE, NULL);
  if (res == -1)
  {
    log("Startup : _beginthread (fork) error (at run server thread).");
    quit(-1);
  }
  log("Main thread : Server and log threads started .");
#ifdef UNIX_VERSION
  if (flag_unattended)
  {
    gl->number_threads--;
    shmdt((void *) gl);
    exit(0);
  }
  unset_signals();
  signal(SIGUSR1, exitsig);
#else
  set_signals();
#endif				/* UNIX_VERSION */
  menu(flag_ansi, gl);
#ifndef UNIX_VERSION
  DosKillThread(gl->server_pid);
  (void) quit(0);
#else
  thrid = gl->server_pid;
  shmdt((void *) gl);
  kill(thrid, SIGUSR1);
  exit(0);
#endif				/* !UNIX_VERSION */
}

SIGFUNC_DECL
quit(int x)
{
  int             i;

  unset_signals();
  signal(SIGUSR1, SIG_IGN);
  if (x != -1)
    log("Main thread : Exit (signal %d) .", x);
  else
    log("Main thread : Error at startup .");
  DosSleep(1000);
#ifdef UNIX_VERSION
  killpg(0, SIGUSR1);
#else
  if (gl->log_pid != -1)
    DosKillThread(gl->log_pid);
#endif				/* UNIX_VERSION */
  DosSleep(1000);

  free(econtent);
  free(echarset);
  free(emime);
  free(emeta);
  free(eendhttp);
  free(eendsmtp);
  free(eendbody);
  free(elength);
  free(epersist);
  free(elife);
  free(eclose);
  free(elinelog);
  for (i = 0; i < 5; i++)
    free(etable[i]);
  if (logerr != stderr)
  {
    fclose(logerr);
  }
  if (!flag_unattended || (logerr != stderr))
    _close_message(msglog);
#ifdef UNIX_VERSION
  shmdt((void *) gl);
  shmctl(global_id, IPC_RMID, NULL);
#endif
  soclose(sock);
  sock_deinit();
  exit(x);
}

void            _Optlink
server_thread(void *socknum)
{
  struct sockaddr_in client;
  int             res;
  int             slen;
  int             rc;
  struct linger   ling;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  set_signals();
#endif				/* UNIX_VERSION */

#ifdef NT_VERSION
  DuplicateHandle(GetCurrentProcess(), GetCurrentThread(), GetCurrentProcess(),
		  &gl->server_pid, 0, TRUE, DUPLICATE_SAME_ACCESS);
#else
  gl->server_pid = gettid();
#endif

  do
  {
    slen = sizeof(client);
    res = accept(sock, (struct sockaddr *) & client, &slen);
    if (res >= 0)
    {
      log("Server thread : New request from address %s .",
	  inet_ntoa(client.sin_addr));
      if ((gl->number_threads + 1) > max_threads)
      {
	log("Server thread : Too many thread . New request rejected .");
	soclose(res);
      } else
      {
	if (linger)
	{
	  ling.l_onoff = 1;
	  ling.l_linger = linger_time;
	} else
	{
	  ling.l_onoff = 0;
	  ling.l_linger = 0;
	}
	setsockopt(res, SOL_SOCKET, SO_LINGER, (char *) &ling, sizeof(ling));

	if (one_thread)
	  rc = _beginthread(&REQUEST_ONE, NULL, THREAD_STACK_SIZE, (void *) res);
	else
	  rc = _beginthread(&REQUEST_MULTI, NULL, THREAD_STACK_SIZE, (void *) res);
	if (rc == -1)
	{
	  log("Server thread : _beginthread (fork) error (at run new_request thread) .");
#ifndef UNIX_VERSION
	  soclose(res);
#endif
	}
#ifdef UNIX_VERSION
	soclose(res);
	shmdt((void *) gl);
	if (fork() > 0)
	  exit(0);
	gl = (struct shared_data *) shmat(global_id, NULL, 0);
	gl->server_pid = getpid();
#endif				/* UNIX_VERSION */
      }
    }
  } while (!gl->flag_exit);
#ifdef UNIX_VERSION
  (void) quit(0);
#endif
  _endthread();
}

char           *
to_regexp(char *s)
{
  char           *out;
  int             i, j;
  char            c;

  out = (char *) malloc(strlen(s) * 4 + 1);
  j = 0;
  for (i = 0; i < strlen(s); i++)
  {
    c = s[i];
    if (isalpha(c))
    {
      out[j] = '[';
      j++;
      out[j] = toupper(c);
      j++;
      out[j] = tolower(c);
      j++;
      out[j] = ']';
      j++;
    } else if (c == '.')
    {
      out[j] = '\\';
      j++;
      out[j] = '.';
      j++;
    } else
    {
      out[j] = c;
      j++;
    }
  }
  out[j] = '\0';
  return out;
}

int
table_number(int t)
{
  switch (t)
  {
    case 0:
    return 0;
  case 1:
    return 3;
  case 866:
    return 4;
  case 1251:
    return 1;
  case 8859:
    return 2;
  default:
    return 4;
  }
}

void
menu(int flag_ansi, struct shared_data * gl)
{
  char            ch;
  char           *str1, *str2;
  int             i;
  char           *a[6] = {"\x1b[0;37;40m", "\x1b[H\x1b[2J\x1b[1;32;40m", "\x1b[1;37;40m", \
  "\x1b[1;36;40m", "\x1b[1;33;40m", "\x1b[1;37;42m"};

  if (flag_ansi == 0)
    for (i = 0; i < 6; i++)
      a[i] = "";

  do
  {
    if (flag_unattended || feof(stdin) || ferror(stdin))
    {
  bigloop:
      DosSleep(10000);
      goto bigloop;
    }
    printf("%sCHCP Proxy version %s (%s) by Vasim V.%s\n",
	   a[1], VERSION_STRING, COMPILER_VERSION, a[0]);
    if (gl->flag_all_translate)
      str1 = "(All bytes)";
    else
      str1 = "(Text only)";
    if (gl->flag_hex_translate)
      str2 = "(Hex chars)";
    else
      str2 = "(No hex)";
    printf("Current translation : %s%s%s <-> %s%s %s %s%s\n",
	   a[2], table_name[gl->translate_from_page], a[0],
	   a[2], table_name[gl->translate_to_page], str1, str2, a[0]);
    printf("\tSearch substring \'; charset=xxx\' option : %s%s%s\n",
	   a[2], flpri_name[gl->flag_charset_priority], a[0]);
    printf("\tCut from MIME-header option : %s%s%s\n\tCut from META (with Content-Type) : %s%s%s\n",
	   a[2], flrep_name[1 + gl->flag_replace_mime], a[0],
	   a[2], flrep_name[1 + gl->flag_replace_meta], a[0]);
    printf("%s\t\tKeys :%s\n%sTranslate from (server's codepage) :%s\n",
	   a[3], a[0], a[4], a[0]);
    printf("\t%s1%s From KOI-8\n\t%s2%s From CP 1251\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s3%s From ISO-8859-5\n\t%s4%s From your codepage\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s5%s From CP 866\n%sTranslate to (client's codepage) :%s\n",
	   a[5], a[0], a[4], a[0]);
    printf("\t%s6%s To KOI-8\n\t%s7%s To CP 1251\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s8%s To ISO-8859-5\n\t%s9%s To your codepage\n",
	   a[5], a[0], a[5], a[0]);
    printf("\t%s0%s To 866\n",
	   a[5], a[0]);
    printf("%sA%s Translate all\n%sH%s Translate hex chars in requests\n",
	   a[5], a[0], a[5], a[0]);
    printf("%sP%s Change search order for substring \'; charset=xxx\'\n",
	   a[5], a[0]);
    printf("%sT%s Change \'Cut from MIME-header\' option\n",
	   a[5], a[0]);
    printf("%sY%s Change \'Cut from META\' option\n",
	   a[5], a[0]);
    printf("%sE%s Exit program\n",
	   a[5], a[0]);
#ifndef USE_CONIO
    printf("\t\tYour choice : ");
    ch = getchar();
#else
    ch = getch();
#endif
    if (flag_ansi == 0)
      printf("\n");
    switch (ch)
    {
    case '1':
      {
	gl->translate_from_page = 0;
	break;
      }
    case '2':
      {
	gl->translate_from_page = 1;
	break;
      }
    case '3':
      {
	gl->translate_from_page = 2;
	break;
      }
    case '4':
      {
	gl->translate_from_page = 3;
	break;
      }
    case '5':
      {
	gl->translate_from_page = 4;
	break;
      }
    case '6':
      {
	gl->translate_to_page = 0;
	fill_tables_translation(gl);
	break;
      }
    case '7':
      {
	gl->translate_to_page = 1;
	fill_tables_translation(gl);
	break;
      }
    case '8':
      {
	gl->translate_to_page = 2;
	fill_tables_translation(gl);
	break;
      }
    case '9':
      {
	gl->translate_to_page = 3;
	fill_tables_translation(gl);
	break;
      }
    case '0':
      {
	gl->translate_to_page = 4;
	fill_tables_translation(gl);
	break;
      }
    case 'A':
    case 'a':
      {
	gl->flag_all_translate = !gl->flag_all_translate;
	break;
      }
    case 'H':
    case 'h':
      {
	gl->flag_hex_translate = !gl->flag_hex_translate;
	break;
      }
    case 'P':
    case 'p':
      {
	gl->flag_charset_priority = (gl->flag_charset_priority + 1) % 5;
	break;
      }
    case 'T':
    case 't':
      {
	gl->flag_replace_mime++;
	if (gl->flag_replace_mime == 3)
	  gl->flag_replace_mime = -1;
	if (!gl->flag_replace_mime)
	  gl->flag_replace_mime = 1;
	break;
      }
    case 'Y':
    case 'y':
      {
	gl->flag_replace_meta++;
	if (gl->flag_replace_meta == 3)
	  gl->flag_replace_meta = -1;
	break;
      }
    case 'E':
    case 'e':
      {
	gl->flag_exit = 1;
	break;
      }
    default:
      break;
    }
  } while (!gl->flag_exit);
}

int
bufcut(unsgchar * buf, int sizebuf, int offset, int size)
{
#ifdef DEBUG
  /* DEBUG */
  log("Thread %d : DEBUG : bufcut %x %d %d %d", gettid(), buf, sizebuf, offset, size);
#endif
  if (size == 0)
    return sizebuf;
  memmove(buf + offset, buf + offset + size, sizebuf - offset - size);
  buf[sizebuf - size] = '\0';
  return (sizebuf - size);
}

int
bufreplace(unsgchar * buf, int sizebuf, int offset, int size, unsgchar * replace)
{
  int             len;

#ifdef DEBUG
  /* DEBUG */
  log("Thread %d : DEBUG : bufreplace %x %d %d %d %x", gettid(), buf, sizebuf, offset, size, replace);
#endif

  len = strlen((char *) replace);
#ifdef DEBUG
  /* DEBUG */
  log("Thread %d : DEBUG : bufreplace : length of replace string %d", gettid(), len);
#endif
  if (len > size)
  {
    memmove(buf + offset + len, buf + offset + size, sizebuf - offset - size);
    memcpy(buf + offset, (void *) replace, len);
    buf[sizebuf + len - size] = '\0';
    return (sizebuf + len - size);
  } else
  {
    memcpy(buf + offset, (void *) replace, len);
    return bufcut(buf, sizebuf, offset + len, size - len);
  }
}

int
look_header(unsgchar * buf, int *psize, struct regexp * exp, int flag_replace, struct shared_data * gl)
{
  int             charset, i, len, flag;
  unsgchar       *pstart;
  unsgchar       *pbegin;
  struct regexp   e;
  unsgchar       *startp, *endp;

  REGDUP(&e, exp);
  flag = regexec(&e, (char *) buf);
  startp = (unsgchar *) e.startp[0];
  endp = (unsgchar *) e.endp[0];
  if (!flag)
    return -1;
  else
  {
    pbegin = startp;
    len = endp - startp;
    pstart = (unsgchar *) malloc(len + 1);
    memcpy(pstart, pbegin, len);
    pstart[len] = '\0';
    charset = -1;
    for (i = 0; i < 5; i++)
    {
      REGDUP(&e, etable[i]);
      flag = regexec(&e, (char *) pstart);
      startp = (unsgchar *) e.startp[0];
      endp = (unsgchar *) e.endp[0];
      if (flag)
      {
	charset = i;
	break;
      }
    }
    if (flag_replace == 0)
      *psize = bufcut(buf, *psize,
		      pbegin - buf, len);
    else if ((flag_replace == 1) && (charset > -1))
      *psize = bufreplace(buf, *psize,
			  startp - pstart + pbegin - buf,
			  endp - startp,
			  (unsgchar *) table_name[gl->translate_to_page]);
    else if ((flag_replace == 2) && (charset > -1))
    {
      REGDUP(&e, echarset);
      flag = regexec(&e, (char *) pstart);
      if (flag)
	*psize = bufcut(buf, *psize,
			(unsgchar *) e.startp[0] - pstart + pbegin - buf,
			e.endp[0] - e.startp[0]);
      else
	log("Substring \'; charset=xxx\' not found ! Gluk ...");
    }
    free(pstart);
  }
  if (!flag_dumb_charset || (charset == -1))
    return charset;
  else
    return gl->translate_from_page;
}

void
cut_alive(bufhex * hbuf, struct shared_data * gl)
{
  struct regexp   exp;

  hbuf->buf[hbuf->size + hbuf->offset] = (unsgchar) 0;
  REGDUP(&exp, elife);
  if (regexec(&exp, (char *) (hbuf->buf + hbuf->offset)))
    hbuf->size = bufcut(hbuf->buf + hbuf->offset, hbuf->size,
			(exp.startp[0] - (char *) hbuf->buf - hbuf->offset), exp.endp[0] - exp.startp[0]);
}

void
reset_receive_buffer(buffer * buf, struct shared_data * gl)
{
  buf->fltrans = (gl->flag_all_translate || (buf->dir == 2) || flag_smtp);
  buf->flheadw = ((!gl->flag_all_translate && (!(buf->dir == 2) || flag_smtp)) ? 1 : 0);
  buf->ver = 0;
  buf->fsize = 0;
  buf->lastsend = 0;
  buf->hex.offset = 0;
  buf->hex.flhexw = 0;
  buf->hex.size = 0;
  buf->hex.buf = buf->buf;
  buf->charset = gl->translate_from_page;
}

void
init_receive_buffer(buffer * buf, struct shared_data * gl)
{
  reset_receive_buffer(buf, gl);
  buf->size = 0;
  buf->scount = 0;
  buf->lastsend = 0;
  buf->flconn = 1;
  buf->psend = buf->buf;
}

int
receive_buffer(buffer * buf, struct shared_data * gl, int *stat, int *flag_stop)
{				/* -1 - error at receive 0 - no bytes receive
				 * (for future extension) 1 - need more
				 * receive 2 - need send (scount bytes from
				 * psend) 3 - all data received */
  regexp          e;
  int             test_header;
  int             need;
  int             res, res1;
  int             s_err;
  unsgchar        tempc;
  int             fsize;
  unsgchar        sbuf[16];
  unsgchar       *tempp, *temppx;
  int             charset;
  int             temps, temps1;
  char		  linelog[MAX_SIZE_LOG_RECORD];
  struct sockaddr_in client;
  int		  namelen;
  int		  to_end_body;

  test_header = 0;
#ifdef DEBUG
  /* DEBUG */
  log("Thread %d : DEBUG : hex.offset %d, scount %d, fsize %d, size %d, flheadw %d, lastsend %d, dir %d, flconn %d, buf %x",
      gettid(), buf->hex.offset, buf->scount, buf->fsize, buf->size, buf->flheadw, buf->lastsend, buf->dir, buf->flconn, buf->buf);
#endif
  if (buf->scount > 0)
  {
    if (!buf->flconn)
      return 2;
  } else
  {
    buf->size = buf->size - buf->lastsend;
    if ((buf->lastsend > 0) && ((buf->fsize <= 0) && (((buf->dir == 1) && !buf->flheadw) || flag_smtp)))
    {
      if (buf->size > 0)
      {
	memmove(buf->buf + buf->hex.offset, buf->buf + buf->lastsend, buf->size);
	if (!flag_smtp || buf->flheadw) test_header = 1;
      }
      if (buf->hex.offset > 0)
      {
	buf->size = buf->size + buf->hex.offset;
	buf->scount = buf->hex.offset;
	if (buf->hex.offset == 1)
	{
	  if (buf->hex.flhexw == 2)
	    buf->buf[0] = hexhead;
	  else
	    buf->buf[0] = buf->hex.hexchar;
	} else
	{
	  buf->buf[0] = hexhead;
	  buf->buf[1] = buf->hex.hexchar;
	}
	buf->lastsend = buf->scount;
	buf->hex.offset = 0;
	return 2;
      }
      if (!flag_smtp && !buf->flheadw)
      {
#ifdef DEBUG
      /* DEBUG */
        log("Thread %d : DEBUG : Reset buffer (%d)", gettid(), buf->size);
#endif
        reset_receive_buffer(buf, gl);
      }
    }
  }

  buf->lastsend = 0;
  res = 0;
  if (!test_header)
  {
    if (buf->flconn)
    {
      need = sizeof(buf->buf) - buf->hex.offset;
      if (buf->flheadw || flag_smtp)
	need = need - RESERVE_BYTES;
      else if (buf->ver && (buf->fsize < need))
	need = buf->fsize;
      need = need - buf->size;
      if (need <= 0)
      {
	log("Thread %d : Gluk in receive_buffer() ! Need receive %d bytes (in buffer %d) .", gettid(), need, buf->size);
	return -1;
      }
#ifdef DEBUG
      /* DEBUG */
      log("Thread %d : DEBUG : need %d", gettid(), need);
#endif
      res = recv(buf->sock, buf->buf + buf->size + buf->hex.offset, need, 0);
#ifdef DEBUG
      /* DEBUG */
      log("Thread %d : DEBUG : received %d bytes, buf->size %d", gettid(), res, buf->size);
#endif
      if (*flag_stop)
        return -1;
      if (res == 0)
      {
	buf->flconn = 0;
	if (buf->size <= 0)
	  return 3;
      } else if (res < 0)
      {
	s_err = ERRNO;
	if (s_err != S_EINTR)
	{
	  log("Thread %d : Problem at receive (%d) (direction %d) .", gettid(), s_err, buf->dir);
	  return -1;
	} else
	{
	  log("Thread %d : EINTR detected at receive (direction %d) .", gettid());
	  res = 0;
	}
      }
    } else
    {
      res = 0;
      if (buf->size <= 0)
      	return 3;
    }
      if ((res > 0) || ((buf->size > 0) && !buf->flheadw))
      {
	*stat = *stat + res;
	if (!buf->flheadw)
	{
	  if (buf->ver)
	    buf->fsize = buf->fsize - res;
	  buf->hex.size = res;
	  buf->hex.buf = buf->buf + buf->size + buf->hex.offset;
	  buf->buf[buf->size + res + buf->hex.offset] = '\0';
	  if (buf->dir == 2)
	  {
#ifdef DEBUG
	    /* DEBUG */
	    log("Thread %d : DEBUG : length of request before %d", gettid(), buf->hex.size);
#endif
	    if (flag_no_alive)
	      cut_alive(&buf->hex, gl);
	    if (flag_host_replace)
	    {
	      REGDUP(&e, ehost);
	      res1 = regexec(&e, (char *) buf->hex.buf);
	      buf->pbegs = (unsgchar *) e.startp[0];
	      buf->pends = (unsgchar *) e.endp[0];
	      if (res1)
	      {
		res = bufreplace(buf->hex.buf, buf->hex.size, buf->pbegs - buf->hex.buf,
			buf->pends - buf->pbegs, (unsgchar *) orighostname);
		buf->hex.size = res;
	      }
	    }
	    if (flag_log_header)
	    {
	      REGDUP(&e, elinelog);
	      res1 = regexec(&e, (char *) buf->buf);
	      if (res1)
	      {
		tempc = (unsgchar) *e.endp[0];
		*e.endp[0] = '\0';
		namelen = sizeof(client);
		memset((void *) & client, 0, namelen);
		getsockname(buf->sock, (struct sockaddr *) & client, & namelen);
		sprintf(linelog, "Thread %d : Client %s : ", gettid(), inet_ntoa(client.sin_addr));
		strncat(linelog, e.startp[0], MAX_SIZE_LOG_RECORD - 1 - strlen(linelog)); /* ICC really need snprintf ! */
		*e.endp[0] = (char) tempc;
	        log("%s",linelog);
	      }
	    }
#ifdef DEBUG
	    /* DEBUG */
	    log("Thread %d : DEBUG : length of request after %d", gettid(), buf->hex.size);
#endif
	  }
	  fsize = buf->hex.size;
	  if (flag_smtp)
	  {
	    buf->hex.size = buf->size - buf->scount + buf->hex.size;
	    buf->hex.buf = buf->buf + buf->hex.offset + buf->scount;
	    tempp = buf->hex.buf - 1;
	    to_end_body = 0;
	    while ((temppx = (unsgchar *) strchr((char *) (tempp + 1), '\n')) != NULL)
	    {
	      tempp = temppx;
	      if ((buf->size + buf->hex.size) > 1)
	      {
		if (*(tempp - 1) == '.')
		{
		  to_end_body = 2;
		  break;
		}
	        if (*(tempp - 1) == '\r')
		  if (buf->size + buf->hex.size > 2)
		  {
		    if (*(tempp - 2) == '.')
		    {
		      to_end_body = 3;
		      break;
		    }
		  }
	      }
	    }
	    buf->fsize = 0;
	    if (to_end_body > 0)
	    {
	      buf->flheadw = 1;
	    } else
	    {
	      if ((tempp == buf->hex.buf) && (temppx == NULL))
	      {
	        if ((buf->size < MAX_MIME_HEADER_SIZE) && buf->flconn)
		{
		  buf->fsize = 1;
		  return 1;
		}
		else
		  tempp = buf->hex.buf + buf->hex.size - 1;
	      }
	    }
	    fsize = (tempp - buf->hex.buf) + 1;
	    buf->hex.size = fsize;
	  }
	  temps = buf->hex.size - fsize;
	  if ((buf->fltrans) && (gl->flag_hex_translate))
	    translate_hex(&buf->hex, fsize, buf->dir, gl, buf->charset);
	  res = buf->hex.size;
	  if (buf->size < (buf->hex.buf - buf->buf + res))
	    buf->size = (buf->hex.buf - buf->buf) + res;
	  if ((res > 0) || !buf->flconn)
	  {
	    if (buf->fltrans)
	      translate(buf->hex.buf, res, buf->dir, buf->charset, gl);
	    buf->scount = buf->scount + res;
	    buf->lastsend = buf->scount;
#ifdef DEBUG
	    /* DEBUG */
	    log("Thread %d : DEBUG : to send %d bytes", gettid(), buf->scount);
#endif
	    return 2;
	  } else
	    return 1;
	} else
	  buf->size = buf->size + res;
    }
  }
  if (buf->flheadw)
  {
    if ((buf->flheadw == 1) && !flag_smtp)
    {
      test_header = 0;
      res = ((buf->size >= MAX_MIME_HEADER_SIZE) || !buf->flconn);
      if ((flag_fast_send && (buf->size >= FAST_HEADER_SIZE)) || res)
      {
	buf->buf[buf->size] = '\0';
	REGDUP(&e, eendhttp);
	test_header = regexec(&e, (char *) buf->buf);
	buf->pend = (unsgchar *) e.endp[0];
      }
      if (test_header || res)
      {
	if (!test_header)
	{
	  log("Thread %d : Error at search end of MIME-header .", gettid());
	  buf->fltrans = gl->flag_all_translate;
	  buf->flheadw = 0;
	  buf->ver = 0;
	  if (buf->fltrans)
	  {
	    buf->hex.size = buf->size;
	    buf->hex.buf = buf->buf + buf->hex.offset;
	    if (gl->flag_hex_translate)
	    {
	      translate_hex(&buf->hex, buf->size, buf->dir, gl, buf->charset);
	      buf->size = buf->hex.size;
	    }
	  }
	  if (buf->size > 0)
	  {
	    if (buf->fltrans)
	      translate(buf->hex.buf, buf->size, buf->dir, buf->charset, gl);
	    buf->scount = buf->size;
	    buf->lastsend = buf->size;
#ifdef DEBUG
	    /* DEBUG */
	    log("Thread %d : DEBUG : to send %d bytes", gettid(), buf->scount);
#endif
	    return 2;
	  } else
	  {
	    if (buf->flconn)
	      return 1;
	    else
	      return 3;
	  }
	} else
	{
	  buf->flheadw = 2;
	  tempc = *buf->pend;
	  *buf->pend = '\0';
	  REGDUP(&e, econtent);
	  buf->fltrans = regexec(&e, (char *) buf->buf);
	  tempp = (unsgchar *) e.startp[0];
	  REGDUP(&e, epersist);
	  res = regexec(&e, (char *) buf->buf);
	  if (res)
	  {
	    buf->ver = 1;
	    REGDUP(&e, elength);
	    if (regexec(&e, (char *) buf->buf))
	    {
	      buf->pbegs = (unsgchar *) e.startp[0] + 15;
	      while (!isdigit(*buf->pbegs))
		buf->pbegs++;
	      fsize = (int) strtol((char *) buf->pbegs, (char **) &buf->pends, 10);
	      log("Thread %d : \'Content-Length:\' detected (%d) .", gettid(), fsize);
	    } else
	    {
	      fsize = 0;
	      REGDUP(&e, eclose);
	      if (regexec(&e, (char *) buf->buf))
	      {
		buf->ver = 0;
		buf->length = 0;
	      }
	    }
	    if (fsize == 0)
	      buf->flheadw = 0;
	    buf->length = fsize;
	  } else
	  {
	    buf->ver = 0;
	    buf->length = 0;
	    fsize = 0;
	  }
	  if (buf->fltrans)
	  {
	    temps = buf->size - (tempp - buf->buf);
	    temps1 = temps;
	    buf->charset_mime = look_header(tempp, &temps, emime, gl->flag_replace_mime, gl);
	    if (temps1 != temps)
	    {
	      buf->size = temps + (tempp - buf->buf);
	      buf->pend = buf->pend + temps - temps1;
	    }
	    if ((buf->charset_mime > -1) && ((gl->flag_charset_priority == 1)
					 || (gl->flag_charset_priority == 3)
				       || (gl->flag_charset_priority == 4)))
	      buf->charset = buf->charset_mime;
	  } else
	    buf->flheadw = 0;
	  *buf->pend = tempc;
	  buf->fsize = fsize + buf->pend - buf->buf;
	}
      } else
      {
	if (!buf->flconn)
	{
	  buf->ver = 0;
	  buf->fsize = 0;
	  buf->fltrans = gl->flag_all_translate;
	  buf->flheadw = 0;
	} else
	  return 1;
      }
    } else if ((buf->flheadw == 1) && flag_smtp)
    {
      if (buf->size > 0)
      {
	buf->charset = gl->translate_from_page;
	buf->buf[buf->size] = '\0';
	buf->pend = (unsgchar *) strchr((char *) buf->buf, '\n');
	if (buf->pend != NULL)
	{
	  temps = buf->size;
	  tempc = *(buf->pend + 1);
	  *(buf->pend + 1) = '\0';
	  buf->charset_mime = look_header(buf->buf, &temps, emime, gl->flag_replace_mime, gl);
	  if (temps != buf->size)
	  {
#ifdef DEBUG
	/* DEBUG */
	    log("Thread %d : DEBUG : Buffer size changed from %d to %d", gettid(), buf->size, temps);
#endif
	    buf->pend = buf->pend + (temps - buf->size);
	    buf->size = temps;
	  }
	  *(buf->pend + 1) = tempc;
	  if ((buf->charset_mime > -1) && !flag_dumb_charset)
	  {
	    buf->charset = buf->charset_mime;
	    log("Thread %d : Charset found in message header . Translation from %s .", gettid(), table_name[buf->charset]);
	    buf->flheadw = 0;
	  }
	} else
	{
	  if ((buf->size < MAX_MIME_HEADER_SIZE) && buf->flconn)
	    return 1;
	  else
	    buf->pend = buf->buf + buf->size - 1;
	}
	buf->fsize = buf->pend - buf->buf + 1;
	buf->ver = 1;
#ifdef DEBUG
	/* DEBUG */
	log("Thread %d : DEBUG : size of last full line %d", gettid(), buf->fsize);
#endif
      } else
      {
	/* DEBUG */
	log("End receive header ???");
	if (buf->flconn)
          return 1;
	else
	  return 3;
      }
    }
    if (buf->flheadw == 2)
    {
      if ((buf->size >= (MAX_MIME_HEADER_SIZE + MAX_META_HEADER_SIZE)) ||
	  (buf->length && (buf->fsize <= buf->size)) ||
	  ((buf->ver == 0) && !buf->flconn))
      {
	buf->buf[buf->size] = '\0';
	temps = buf->size;
	temps1 = temps;
	charset = look_header(buf->buf, &temps, emeta, gl->flag_replace_meta, gl);
	if (temps1 != temps)
	{
	  buf->size = temps;
	  if (buf->ver)
	    buf->fsize = buf->fsize + temps - temps1;
	  if (buf->length)
	  {
	    buf->length = buf->length + temps - temps1;
	    sprintf((char *) sbuf, "%d", buf->length);
	    buf->size = bufreplace(buf->buf, buf->size,
		      buf->pbegs - buf->buf, buf->pends - buf->pbegs, sbuf);
	  }
	}
#ifdef DEBUG
	/* DEBUG */
	log("Thread %d : DEBUG buf->size %d , buf->fsize %d , buf->length %d", gettid(), buf->size, buf->fsize, buf->length);
#endif
	if (charset > -1)
	{
	  if ((gl->flag_charset_priority == 2)
	      || (gl->flag_charset_priority == 4))
	    buf->charset = charset;
	  if ((gl->flag_charset_priority == 3)
	      && (buf->charset_mime < 0))
	    buf->charset = charset;
	}
	buf->flheadw = 0;
      } else
      {
	if (!buf->flconn)
	  buf->flheadw = 0;
	else
	  return 1;
      }
    }
    if ((!buf->flheadw || flag_smtp) && (buf->size > 0))
    {
      if ((buf->fsize < buf->size) && buf->ver)
	temps = buf->fsize;
      else
	temps = buf->size;
      if (buf->ver)
	buf->fsize = buf->fsize - temps;
      if (buf->fltrans)
      {
	if (!flag_smtp)
	{
	  if (buf->ver)
	    log("Thread %d : Text file . Translation from %s . Length %d .", gettid(), table_name[buf->charset], buf->length);
	  else
	    log("Thread %d : Text file . Translation from %s .", gettid(), table_name[buf->charset]);
	}
	buf->hex.size = temps;
	buf->hex.buf = buf->buf + buf->hex.offset;
	if (gl->flag_hex_translate)
	{
	  translate_hex(&buf->hex, temps, buf->dir, gl, buf->charset);
	  if (temps == buf->size)
	  {
	    temps = buf->hex.size;
	    buf->size = buf->hex.size;
	  }
	}
	translate(buf->hex.buf, temps, buf->dir, buf->charset, gl);
      }
      buf->scount = temps;
      buf->lastsend = temps;
#ifdef DEBUG
      /* DEBUG */
      log("Thread %d : DEBUG : to send %d bytes", gettid(), buf->scount);
#endif
      return 2;
    }
  }
  return 0;
}

void
set_buffer_size(int sock1, int sock2)
{
  SBUF            opt;

  if (receive_buffer_size > 0)
  {
#ifdef DEBUG
    /* DEBUG */
    log("Thread %d : DEBUG : receive buffer size %d", gettid(), receive_buffer_size);
#endif
    opt = (SBUF) receive_buffer_size;
    setsockopt(sock1, SOL_SOCKET, SO_RCVBUF, (char *) &opt, sizeof(opt));
    opt = (SBUF) receive_buffer_size;
    setsockopt(sock2, SOL_SOCKET, SO_RCVBUF, (char *) &opt, sizeof(opt));
  }
  if (send_buffer_size > 0)
  {
#ifdef DEBUG
    /* DEBUG */
    log("Thread %d : DEBUG : send buffer size %d", gettid(), send_buffer_size);
#endif
    opt = (SBUF) send_buffer_size;
    setsockopt(sock1, SOL_SOCKET, SO_SNDBUF, (char *) &opt, sizeof(opt));
    opt = (SBUF) send_buffer_size;
    setsockopt(sock2, SOL_SOCKET, SO_SNDBUF, (char *) &opt, sizeof(opt));
  }
}

int
new_connection(int insock)
{
  int             proxysock;
  struct sockaddr_in proxy;

  log("Thread %d : New connection .", gettid());
  proxysock = socket(AF_INET, SOCK_STREAM, 0);
  if (proxysock < 0)
  {
    log("Thread %d : Error (%d) at create socket .", gettid(), ERRNO);
    return -1;
  }
  set_buffer_size(insock, proxysock);

  proxy.sin_family = AF_INET;
  proxy.sin_port = htons(proxy_port);
  proxy.sin_addr.s_addr = proxy_address;
  if (connect(proxysock, (struct sockaddr *) & proxy, sizeof(proxy)) < 0)
  {
    log("Thread %d : Error (%d) at connect to proxy .", gettid(), ERRNO);
    return -1;
  }
  return proxysock;
}

void
close_connection(int insock, int statr0, int statr1, int stats0, int stats1)
{
  log("Thread %d : Connection closed (client: %d->%d proxy: %d->%d) .", gettid(),
      statr0, stats1, statr1, stats0);
#ifdef CLOSE_WAIT
  DosSleep(1000 * SEND_TIME_WAIT);
#endif
  shutdown(insock, 2);
  soclose(insock);
}

#ifdef UNIX_VERSION
sockets	       *socks;
int             socks_id;

SIGFUNC_DECL
deattach_parent(int x)
{
  socks->parent_pid = 0;
  signal(SIGUSR1, SIG_IGN);
  if (socks->child_pid != 0)
    kill(socks->child_pid, SIGUSR1);
  gl->number_threads--;
  shmdt((void *) socks);
  shmdt((void *) gl);
  shmctl(socks_id, IPC_RMID, 0);
  exit(0);
}

SIGFUNC_DECL
close_sockets(int x)
{
  signal(SIGUSR2, SIG_IGN);
  soclose(socks->in_sock);
  soclose(socks->proxy_sock);
  return ;
}

SIGFUNC_DECL
deattach_child(int x)
{
  socks->child_pid = 0;
  signal(SIGUSR1, SIG_IGN);
  soclose(socks->in_sock);
  soclose(socks->proxy_sock);
  gl->number_threads--;
  if (socks->parent_pid != 0)
    kill(socks->parent_pid, SIGUSR2);
  shmdt((void *) socks);
  shmdt((void *) gl);
  exit(0);
}
#endif				/* UNIX_VERSION */

void            _Optlink
new_request(void *num_socket)
{
  buffer         *buf;
  int             res;
  sockets	  tempsocks;
#ifdef UNIX_VERSION

  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  socks_id = shmget(IPC_PRIVATE, sizeof(struct sockets), IPC_CREAT | SHM_R | SHM_W);
  if (socks_id < 0)
  {
    log("Thread %d : Error at create shared memory segment .", gettid());
    socks = &tempsocks;
    socks->child_pid = 0;
    socks->in_sock = (int) num_socket;
    gl->number_threads++;
    goto exit;
  }
  socks = (sockets *) shmat(socks_id, NULL, 0);
  unset_signals();
  signal(SIGUSR1, deattach_parent);
  signal(SIGUSR2, close_sockets);
  soclose(sock);
#else
  sockets	 *socks;

  socks = &tempsocks;
  socks->hev = _create_event();
  _reset_event(socks->hev);
#endif				/* UNIX_VERSION */

  socks->statr0 = 0;
  socks->stats0 = 0;
  socks->statr1 = 0;
  socks->stats1 = 0;
  socks->flag_exit = 2;
  gl->number_threads++;
  buf = (buffer *) malloc(sizeof(buffer));
  socks->table = gl->translate_from_page;
  socks->in_sock = (int) num_socket;
  socks->proxy_sock = new_connection(socks->in_sock);
  if (socks->proxy_sock < 0)
    goto exit;
#ifdef UNIX_VERSION
  socks->parent_pid = gettid();
#endif				/* UNIX_VERSION */
  socks->flag_exit = 0;
  res = _beginthread(&to_proxy_thread, NULL, THREAD_STACK_SIZE, socks);
  if (res == -1)
  {
    log("Thread %d : _beginthread (fork) error (at run to_proxy_thread) .",
	gettid());
    soclose(socks->proxy_sock);
    socks->flag_exit = 2;
    goto exit;
  }
  buf->dir = 1;
  buf->sock = socks->proxy_sock;
  init_receive_buffer(buf, gl);
  do
  {
    res = receive_buffer(buf, gl, &socks->statr1, &socks->flag_exit);
    socks->table = buf->charset;
    if (res == 2)
    {
      res = sendflush(socks->in_sock, buf->psend, buf->scount, &socks->stats0, &socks->flag_exit);
      if (res != buf->scount)
      {
	if (!socks->flag_exit)
	{
	  log("Thread %d : Problem (%d) at send to client .", gettid(), ERRNO);
	  socks->flag_exit = 1;
	}
      } else
      {
#ifdef DEBUG
	/* DEBUG */
	log("Thread %d : Data from %x sent to client (%d bytes)",
	    gettid(), buf->psend, buf->scount);
#endif
	buf->scount = 0;
      }
    } else
    {
      if (res == 3)
      {
	log("Thread %d : Proxy close connection .", gettid());
	socks->flag_exit = 1;
      }
      if ((res == -1) && (!socks->flag_exit))
	socks->flag_exit = 1;
    }
  } while ((!gl->flag_exit) && (!socks->flag_exit));
  shutdown(socks->proxy_sock, 2);
  soclose(socks->proxy_sock);
  free(buf);
exit:
  close_connection(socks->in_sock, socks->statr0, socks->statr1, socks->stats0, socks->stats1);
#ifdef UNIX_VERSION
  (void) deattach_parent(0);
#else
  gl->number_threads--;
  _wait_event(socks->hev);
  _close_event(socks->hev);
  free(socks);
#endif				/* UNIX_VERSION */
  _endthread();
}

void            _Optlink
to_proxy_thread(void *idsocks)
{
  buffer          buf;
  int             res;
#ifdef UNIX_VERSION

  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  socks = (sockets *) shmat(socks_id, NULL, 0);
  signal(SIGUSR1, deattach_child);
  signal(SIGUSR2, SIG_IGN);
#else
  sockets	 *socks;

  socks = (sockets *) idsocks;
#endif				/* UNIX_VERSION */

#ifdef NT_VERSION
  DuplicateHandle(GetCurrentProcess(), GetCurrentThread(), GetCurrentProcess(),
		  &socks->child_pid, 0, TRUE, DUPLICATE_SAME_ACCESS);
#else
  socks->child_pid = gettid();
#endif				/* NT_VERSION */

  gl->number_threads++;
  buf.dir = 2;
  buf.sock = socks->in_sock;
  init_receive_buffer(&buf, gl);

  do
  {
    buf.charset = socks->table;
    res = receive_buffer(&buf, gl, &socks->statr0, &socks->flag_exit);
    if (res == 2)
    {
      res = sendflush(socks->proxy_sock, buf.psend, buf.scount, &socks->stats1, &socks->flag_exit);
      if (res != buf.scount)
      {
	if (!socks->flag_exit)
	{
	  log("Thread %d : Problem (%d) at send to proxy .", gettid(), ERRNO);
	  socks->flag_exit = 1;
	}
	goto exit;
      } else
	buf.scount = 0;
    } else
    {
      if (res == 3)
      {
	log("Thread %d : Client close connection .", gettid());
	socks->flag_exit = 1;
      }
      if ((res == -1) && (!socks->flag_exit))
	socks->flag_exit = 1;
    }
  } while ((!gl->flag_exit) && (!socks->flag_exit));
exit:
#ifdef UNIX_VERSION
  (void) deattach_child(0);
#else
  shutdown(socks->in_sock, 2);
  soclose(socks->in_sock);
  shutdown(socks->proxy_sock, 2);
  soclose(socks->proxy_sock);
  socks->child_pid = 0;
  gl->number_threads--;
  _pulse_event(socks->hev);
#endif				/* UNIX_VERSION */
  _endthread();
}

void
translate(unsgchar * buf, int size, int flag_translate, int table, struct shared_data * gl)
{
  int             i;

  switch (flag_translate)
  {
  case 0:
    return;
  case 1:
    {
      for (i = 0; i < size; i++)
	buf[i] = gl->table_from[table][buf[i]];
      return;
    }
  case 2:
    {
      for (i = 0; i < size; i++)
	buf[i] = gl->table_to[table][buf[i]];
      return;
    }
  }
  return;
}

int
sendflush(int sock, unsgchar * buf, int size, int *stat, int *flag_stop)
{
  int             res, count;

  count = 0;
  do
  {
    res = send(sock, buf, size, 0);
    if (res < 0)
    {
      if (*flag_stop)
        return size;
      if (ERRNO != S_EINTR)
	return -1;
      else
	res = 0;
    }
    count = count + res;
    *stat = *stat + res;
  } while (count < size);
  return size;
}

_Inline int
xc2d(unsgchar c)
{
  int             temp;

  temp = toupper(c) - '0';
  if (temp > 9)
    return (temp - 'A' + '9' + 1);
  else
    return temp;
}

_Inline         unsgchar
d2xc(int k)
{
  if (k > 9)
    return (k + 'A' - 10);
  else
    return (k + '0');
}

_Inline void
hex_translate(unsgchar * buf, int flag_translate, int table, struct shared_data * gl)
{
  unsgchar        temp;

  if ((!isxdigit(buf[0])) || (!isxdigit(buf[1])))
    return;
  switch (flag_translate)
  {
  case 0:
    return;
  case 1:
    {
      temp = gl->table_from[table][xc2d(buf[0]) * 16 + xc2d(buf[1])];
      break;
    }
  case 2:
    {
      temp = gl->table_to[table][xc2d(buf[0]) * 16 + xc2d(buf[1])];
      break;
    }
  default:
    return;
  }
  buf[0] = d2xc(temp / 16);
  buf[1] = d2xc(temp % 16);
  return;
}

unsgchar
char_num(int ch, unsgchar * table)
{
  int             i;

  for (i = 0; ((i < 224) && (*(table + i) != (unsgchar) ch)); i++);
  if (i == 224)
    i = ch - 32;
  return (unsgchar) (i + 32);

}

void
fill_tables_translation(struct shared_data * gl)
{
  int             i, j;

  for (i = 0; i < 32; i++)
  {
    gl->table_to[0][i] = (unsgchar) i;
    gl->table_from[0][i] = (unsgchar) i;
    gl->table_to[1][i] = (unsgchar) i;
    gl->table_from[1][i] = (unsgchar) i;
    gl->table_to[2][i] = (unsgchar) i;
    gl->table_from[2][i] = (unsgchar) i;
    gl->table_to[3][i] = (unsgchar) i;
    gl->table_from[3][i] = (unsgchar) i;
    gl->table_to[4][i] = (unsgchar) i;
    gl->table_from[4][i] = (unsgchar) i;
  }
  for (i = 0; i < 5; i++)
  {
    memset(gl->table_from[i] + 32, 32, 224);
    memset(gl->table_to[i] + 32, 32, 224);
    for (j = 32; j < 256; j++)
    {
      if (i == gl->translate_to_page)
      {
	gl->table_from[i][j] = j;
	gl->table_to[i][j] = j;
      } else
      {
	if (i == 4)
	{
	  gl->table_from[i][j] = char_num(j, tbcp[gl->translate_to_page]);
	  gl->table_to[i][j] = tbcp[gl->translate_to_page][j - 32];
	} else
	{
	  if (gl->translate_to_page == 4)
	  {
	    gl->table_from[i][j] = tbcp[i][j - 32];
	    gl->table_to[i][j] = char_num(j, tbcp[i]);
	  } else
	  {
	    gl->table_from[i][j] = char_num(tbcp[i][j - 32],
					    tbcp[gl->translate_to_page]);
	    gl->table_to[i][j] = char_num(tbcp[gl->translate_to_page][j - 32],
					  tbcp[i]);
	  }
	}
      }
    }
  }
  return;
}

void
load_table(int table, char *filename)
{
  FILE           *f;
#ifdef USE_DEFAULT_DATA_DIR
  char            bufname[256];

  sprintf(bufname, "%s/%s", DEFAULT_DATA_DIR, filename);
  f = fopen(bufname, "rb");
  if (f == NULL)
  {
#endif				/* USE_DEFAULT_DATA_DIR */
    f = fopen(filename, "rb");
    if (f == NULL)
    {
      fprintf(stderr, "Codepage file %s not loaded\n", filename);
      quit(4);
    }
#ifdef USE_DEFAULT_DATA_DIR
  }
#endif
  fread(tbcp[table], 224, 1, f);
  fclose(f);
  return;
}

#ifdef UNIX_VERSION
SIGFUNC_DECL
deattach(int x)
{
  signal(SIGUSR1, SIG_IGN);
  gl->number_threads--;
  shmdt((void *) gl);
  exit(x);
}
#endif				/* UNIX_VERSION */

void            _Optlink
log_thread(void *nullpar)
{
  char            msg[MAX_SIZE_LOG_RECORD + 1];
  time_t          ltime;
  struct tm      *ntime;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  unset_signals();
  signal(SIGUSR1, deattach);
#endif				/* UNIX_VERSION */

#ifdef NT_VERSION
  DuplicateHandle(GetCurrentProcess(), GetCurrentThread(), GetCurrentProcess(),
		  &gl->log_pid, 0, TRUE, DUPLICATE_SAME_ACCESS);
#else
  gl->log_pid = gettid();
#endif				/* NT_VERSION */

  msg[MAX_SIZE_LOG_RECORD] = (char) 0;
  do
  {
    _receive_message(msglog, msg);
    time(&ltime);
    ntime = localtime(&ltime);
    fprintf(logerr, "%s\t%s\n", asctime(ntime), msg);
#ifdef FLUSH_LOG
    fflush(logerr);
#endif
  } while (1);
}

void
log(const char *fmt,...)
{
  va_list         ap;
  char            strlog[MAX_SIZE_LOG_RECORD];

  if (!flag_unattended || (logerr != stderr))
  {
    va_start(ap, fmt);
    vsprintf(strlog, fmt, ap);
    va_end(ap);
    _send_message(msglog, strlog);
  }
}

void
translate_hex(bufhex * hbuf, int size, int flag_translate, struct shared_data * gl, int table)
{
  int             flbuf, temps;
  unsgchar       *findbuf;

  temps = size;
  flbuf = (hbuf->size == size);
  if (size == 0)
    return;
  switch (hbuf->flhexw)
  {
  case 1:
    {
      hbuf->buf--;
      hbuf->size++;
      temps++;
      *hbuf->buf = hbuf->hexchar;
      hex_translate(hbuf->buf, flag_translate, table, gl);
      hbuf->flhexw = 0;
      hbuf->offset = 0;
      break;
    }
  case 2:
    {
      if (size > 1)
      {
	hbuf->buf--;
	hbuf->size++;
	temps++;
	*hbuf->buf = hexhead;
	hbuf->flhexw = 0;
	hbuf->offset = 0;
      } else
      {
	hbuf->hexchar = *hbuf->buf;
	hbuf->size--;
	hbuf->flhexw = 3;
	hbuf->offset = 2;
	return;
      }
      break;
    }
  case 3:
    {
      hbuf->buf--;
      *hbuf->buf = hbuf->hexchar;
      hbuf->buf--;
      *hbuf->buf = hexhead;
      hbuf->size = hbuf->size + 2;
      temps = temps + 2;
      hbuf->flhexw = 0;
      hbuf->offset = 0;
      break;
    }
  }
  findbuf = hbuf->buf;
  while ((findbuf = (unsgchar *) memchr(findbuf, (int) hexhead,
				    (hbuf->buf - findbuf) + temps)) != NULL)
  {
    if ((hbuf->buf + temps - findbuf) > 2)
      hex_translate(findbuf + 1, flag_translate, table, gl);
    else
    {
      if (flbuf)
      {
	if ((hbuf->buf + hbuf->size - 1) == findbuf)
	{
	  hbuf->size--;
	  hbuf->flhexw = 2;
	  hbuf->offset = 1;
	  break;
	} else
	{
	  hbuf->hexchar = findbuf[1];
	  hbuf->size--;
	  hbuf->flhexw = 1;
	  hbuf->offset = 1;
	}
      }
    }
    findbuf++;
  }
  return;
}

void            _Optlink
Request(void *num_socket)
{
  buffer         *sbuf;
  buffer         *rbuf;
  fd_set          fdsr;
  fd_set          fdss;
  fd_set          fdse;
  int             res;
  int             flend, flendw;
  int             insock, proxysock;
  int             flsend_in, flsend_proxy, flrecv_in, flrecv_proxy;
  int             statr0, statr1;
  int             stats0, stats1;
  int             flnewfile;
  int		  dummy;

#ifdef UNIX_VERSION
  gl = (struct shared_data *) shmat(global_id, NULL, 0);
  unset_signals();
  signal(SIGUSR1, deattach);
  soclose(sock);
#endif
  sbuf = (buffer *) malloc(sizeof(buffer));
  rbuf = (buffer *) malloc(sizeof(buffer));
  statr0 = 0;
  statr1 = 0;
  stats0 = 0;
  stats1 = 0;
  gl->number_threads++;
  insock = (int) num_socket;
  proxysock = new_connection(insock);
  if (proxysock < 0)
    goto exit;
  sbuf->dir = 1;
  rbuf->dir = 2;
  sbuf->sock = proxysock;
  rbuf->sock = insock;
  init_receive_buffer(sbuf, gl);
  init_receive_buffer(rbuf, gl);
  flend = 0;
  flendw = 0;
  flsend_in = 0;
  flsend_proxy = 0;
  flrecv_in = 1;
  flrecv_proxy = 1;
  flnewfile = 0;
  dummy = 0;
  FD_ZERO(&fdsr);
  FD_ZERO(&fdss);
  FD_ZERO(&fdse);
  do
  {
    if (!flnewfile)
    {
      if (flrecv_in)
	FD_SET(insock, &fdsr);
      if (flrecv_proxy)
	FD_SET(proxysock, &fdsr);
      if (flrecv_in || flsend_in)
	FD_SET(insock, &fdse);
      if (flrecv_proxy || flsend_proxy)
	FD_SET(proxysock, &fdse);
      if (flsend_in)
	FD_SET(insock, &fdss);
      if (flsend_proxy)
	FD_SET(proxysock, &fdss);
      res = select(((proxysock > insock) ? proxysock : insock) + 1, &fdsr, &fdss, &fdse, NULL);
    } else
      res = 0;
    if (res > -1)
    {
      if (FD_ISSET(insock, &fdsr))
      {
	FD_CLR(insock, &fdsr);
	rbuf->charset = sbuf->charset;
	res = receive_buffer(rbuf, gl, &statr0, &dummy);
	flrecv_in = rbuf->flconn;
	if (res == 2)
	{
	  flrecv_in = 0;
	  flsend_proxy = 1;
	} else
	{
	  if (res == 3)
	  {
	    log("Thread %d : Client close connection .", gettid());
	    flendw = 1;
	  } else if (res == -1)
	    flend = 1;
	}
      }
      if (FD_ISSET(proxysock, &fdsr) || flnewfile)
      {
	if (FD_ISSET(proxysock, &fdsr))
	{
	  FD_CLR(proxysock, &fdsr);
#ifdef DEBUG
	  /* DEBUG */
	  log("Thread %d : DEBUG : new bytes from proxy", gettid());
#endif
	}
	flnewfile = 0;
	res = receive_buffer(sbuf, gl, &statr1, &dummy);
	flrecv_proxy = sbuf->flconn;
	if (res == 2)
	{
	  flsend_in = 1;
	  flrecv_proxy = 0;
	} else
	{
	  if (res == 3)
	  {
	    log("Thread %d : Proxy close connection .", gettid());
	    flendw = 1;
	  } else if (res == -1)
	    flend = 1;
	}
      }
      if (FD_ISSET(proxysock, &fdss))
      {
	FD_CLR(proxysock, &fdss);
	if (sendflush(proxysock, rbuf->psend, rbuf->scount, &stats1, &dummy) != rbuf->scount)
	{
	  log("Thread %d : Problem (%d) at send to client .", gettid(), ERRNO);
	  flend = 1;
	} else
	{
#ifdef DEBUG
	  /* DEBUG */
	  log("Thread %d : DEBUG : data sent to proxy (%d)", gettid(), rbuf->scount);
#endif
	  rbuf->scount = 0;
	  flsend_proxy = 0;
	  flrecv_in = rbuf->flconn;
	}
      }
      if (FD_ISSET(insock, &fdss))
      {
	FD_CLR(insock, &fdss);
	if (sendflush(insock, sbuf->psend, sbuf->scount, &stats0, &dummy) != sbuf->scount)
	{
	  log("Thread %d : Problem (%d) at send to proxy .", gettid(), ERRNO);
	  flend = 1;
	} else
	{
#ifdef DEBUG
	  /* DEBUG */
	  log("Thread %d : DEBUG : data sent to client (%d)", gettid(), sbuf->scount);
#endif
	  flsend_in = 0;
	  if (!sbuf->flconn)
	    flnewfile = 1;
	  flrecv_proxy = sbuf->flconn;
	  sbuf->scount = 0;
	}
      }
      if (FD_ISSET(insock, &fdse) || FD_ISSET(proxysock, &fdse))
      {
	if (FD_ISSET(insock, &fdse))
	  FD_CLR(insock, &fdse);
	if (FD_ISSET(proxysock, &fdse))
	  FD_CLR(proxysock, &fdse);
	if (ERRNO != S_EINTR)
	{
	  log("Thread %d : Error (%d) at socket", gettid(), ERRNO);
	  flend = 1;
	} else
	  log("Thread %d : EINTR detected at select exceptions .", gettid());
      }
    } else
    {
      if (ERRNO != S_EINTR)
      {
	log("Thread %d : Select return error (%d) .", gettid(), ERRNO);
	flend = 1;
      } else
	log("Thread %d : EINTR detected at select .", gettid());
    }
  } while (!flend && (!(flendw && (rbuf->scount == 0) && (sbuf->scount == 0))));
  shutdown(proxysock, 2);
  soclose(proxysock);
exit:
  free(rbuf);
  free(sbuf);
  close_connection(insock, statr0, statr1, stats0, stats1);
#ifdef UNIX_VERSION
  (void) deattach(0);
#else
  gl->number_threads--;
#endif
  _endthread();
}

#ifdef I_HATE_ifdef
#error Sorry .
#endif
