/* read configuration file */

#include "conf.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "regexp/regexp.h"

#define MAX_LINE_LENGTH 128

int
read_cfg(FILE * in, conf_rec conf[], int conf_param_num)	/* return 0 if sucessful
								 * or number of error
								 * string */
{
  int             n;
  int             curline;
  char            line[MAX_LINE_LENGTH + 1];
  int             already[MAX_CONF_PARAM_NUM];
  regexp         *exp[MAX_CONF_PARAM_NUM];
  regexp         *f_no;
  regexp         *f_yes;
  regexp         *f_number;
  regexp         *f_string;
  regexp          t;
  regexp          comment;
  regexp         *f_comment;
  int             found;
  char           *beg, *end;
  char           *temp;
  int             error;;

  f_no = regcomp(F_NO);
  f_yes = regcomp(F_YES);
  f_number = regcomp(F_NUMBER);
  f_string = regcomp(F_STRING);
  f_comment = regcomp(F_COMMENT);
  for (n = 0; n < conf_param_num; n++)
  {
    already[n] = 0;
    exp[n] = regcomp(conf[n].param);
    if (conf[n].type == 2)
    {
      if (conf[n].len > 0)
	memcpy (*conf[n].addr, conf[n].def, strlen(conf[n].def));
      else
      {
	*conf[n].addr = (void *) malloc(strlen(conf[n].def));
	memcpy (*conf[n].addr, conf[n].def, strlen(conf[n].def));
      }
    } else
      *conf[n].addr = conf[n].def;
  }

  curline = 0;
  error = 0;
  while ((fgets(line, MAX_LINE_LENGTH, in) != NULL) && !error)
  {
    curline++;
    found = 0;
    regdup(&comment, f_comment);
    if (!regexec(&comment, line))
    {
      for (n = 0; n < conf_param_num; n++)
      {
	regdup(&t, exp[n]);
	if ((!already[n]) && (regexec(&t, line)))
	{
	  already[n] = 1;
	  found = 1;
	  temp = t.endp[0];
	  switch (conf[n].type)
	  {
	  case 0:
	    {
	      *((int *) conf[n].addr) = 1;
	      break;
	    }
	  case 1:
	    {
	      regdup(&t, f_yes);
	      if (regexec(&t, temp))
	      {
		*((int *) conf[n].addr) = 1;
	      } else
	      {
		regdup(&t, f_no);
		if (regexec(&t, temp))
		{
		  *((int *) conf[n].addr) = 0;
		} else
		  error = 1;
	      }
	      break;
	    }
	  case 2:
	    {
	      regdup(&t, f_string);
	      if (regexec(&t, temp))
	      {
		beg = t.startp[0];
		end = t.endp[0];
		if (conf[n].len > 0)
		{
		  if ((end - beg) >= conf[n].len)
		  {
		    memcpy(*conf[n].addr, beg, conf[n].len - 1);
		    *(*(char **) conf[n].addr + conf[n].len - 1) = '\0';
		  } else
		  {
		    memcpy(*conf[n].addr, beg, (end - beg));
		    *(*(char **) conf[n].addr + (end - beg)) = '\0';
		  }
		} else
		{
		  free(*conf[n].addr);
		  *conf[n].addr = (void *) malloc((int) ((end - beg) + 1));
		  memcpy(*conf[n].addr, beg, (end - beg));
		  *(*(char **) conf[n].addr + (end - beg)) = '\0';
		}
	      } else
		error = 1;
	      break;
	    }
	  case 3:
	    {
	      regdup(&t, f_number);
	      if (regexec(&t, temp))
	      {
		*(t.endp[0] + 1) = '\0';
		*((int *) conf[n].addr) = atoi(t.startp[0]);
	      } else
		error = 1;
	      break;
	    }
	  }
	}
	if (error)
	  break;
      }
      if (!found)
	error = 1;
    }
  }
  if (error)
    return curline;
  else
    return 0;
}
